# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from sbg_driver/SbgUtcTimeStatus.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class SbgUtcTimeStatus(genpy.Message):
  _md5sum = "d140f95192866cb459fe7af2851c8eed"
  _type = "sbg_driver/SbgUtcTimeStatus"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """# SBG Ellipse Messages

# True when a clock input can be used to synchronize the internal clock.
bool clock_stable

# Define the internal clock estimation status
# 0 An error has occurred on the clock estimation.
# 1 The clock is only based on the internal crystal.
# 2 A PPS has been detected and the clock is converging to it.
# 3 The clock has converged to the PPS and is within 500ns.
uint8 clock_status

# True if UTC time is synchronized with a PPS
bool clock_utc_sync

# UTC validity status
# 0 The UTC time is not known, we are just propagating the UTC time internally.
# 1 We have received valid UTC time information but we don't have the leap seconds information.
# 2 We have received valid UTC time data with valid leap seconds.
uint8 clock_utc_status"""
  __slots__ = ['clock_stable','clock_status','clock_utc_sync','clock_utc_status']
  _slot_types = ['bool','uint8','bool','uint8']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       clock_stable,clock_status,clock_utc_sync,clock_utc_status

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SbgUtcTimeStatus, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.clock_stable is None:
        self.clock_stable = False
      if self.clock_status is None:
        self.clock_status = 0
      if self.clock_utc_sync is None:
        self.clock_utc_sync = False
      if self.clock_utc_status is None:
        self.clock_utc_status = 0
    else:
      self.clock_stable = False
      self.clock_status = 0
      self.clock_utc_sync = False
      self.clock_utc_status = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_4B().pack(_x.clock_stable, _x.clock_status, _x.clock_utc_sync, _x.clock_utc_status))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      end = 0
      _x = self
      start = end
      end += 4
      (_x.clock_stable, _x.clock_status, _x.clock_utc_sync, _x.clock_utc_status,) = _get_struct_4B().unpack(str[start:end])
      self.clock_stable = bool(self.clock_stable)
      self.clock_utc_sync = bool(self.clock_utc_sync)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_4B().pack(_x.clock_stable, _x.clock_status, _x.clock_utc_sync, _x.clock_utc_status))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      end = 0
      _x = self
      start = end
      end += 4
      (_x.clock_stable, _x.clock_status, _x.clock_utc_sync, _x.clock_utc_status,) = _get_struct_4B().unpack(str[start:end])
      self.clock_stable = bool(self.clock_stable)
      self.clock_utc_sync = bool(self.clock_utc_sync)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_4B = None
def _get_struct_4B():
    global _struct_4B
    if _struct_4B is None:
        _struct_4B = struct.Struct("<4B")
    return _struct_4B
